# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   test
# FileName:      db.py
# Author:       xxxxx
# Datetime:     2024/12/26 16:59
# Description:
# 
# ---------------------------------------------------------------------------
import pymysql

from APIAutoTest_3 import log_decorator
from APIAutoTest_v3.common.read_basic_ini import ReadBasicIni


class DB:
    @log_decorator
    def __init__(self):
        ini = ReadBasicIni()
        self.conn = pymysql.connect(
            host=ini.get_database_conn_msg("host"),
            port=int(ini.get_database_conn_msg("port")),
            user=ini.get_database_conn_msg("user"),
            password=ini.get_database_conn_msg("pwd"),
            database=ini.get_database_conn_msg("database"),
            charset="utf8"
        )
        self.cursor = self.conn.cursor()

    @log_decorator
    def close(self):
        self.cursor.close()
        self.conn.close()

    @log_decorator
    def delete(self, sql):
        self.cursor.execute(sql)
        self.conn.commit()

    @log_decorator
    def select(self, sql):
        self.cursor.execute(sql)
        select_result = self.cursor.fetchall()
        if select_result is not None:
            return select_result[0][0]
