# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   test
# FileName:      read_basic_ini.py
# Author:       xxxxx
# Datetime:     2024/12/26 17:02
# Description:
# 
# ---------------------------------------------------------------------------
import os.path
from configparser import ConfigParser

from APIAutoTest_3 import log_decorator


class ReadBasicIni:
    @log_decorator
    def __init__(self):
        self.data_config_path =os.path.join(os.path.dirname(os.path.dirname(__file__)),"data_config")
        ini_path = os.path.join(self.data_config_path, "config.ini")
        self.conf = ConfigParser()
        self.conf.read(ini_path, encoding="utf-8")

    @log_decorator
    def get_host(self, key):

        return self.conf.get("host", key)

    @log_decorator
    def get_sql_connect(self, key):#sql节点下的请求头
        return self.conf.get("sql", key)

    @log_decorator
    def get_user_dir_name(self, key):#user节点下的请求头
        user_path = self.conf.get("user", key)
        user_dir_name = os.path.join(self.data_config_path, user_path)
        return user_dir_name

if __name__ == '__main__':
    read_basic_ini = ReadBasicIni()
    print(read_basic_ini.get_host("bpm"))
    print(read_basic_ini.get_sql_connect("host"))
    print(read_basic_ini.get_user_dir_name("farke"))

