# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   test
# FileName:      read_user_ini.py
# Author:       xxxxx
# Datetime:     2024/12/26 17:18
# Description:
# 
# ---------------------------------------------------------------------------
import configparser
import os

from APIAutoTest_3 import log_decorator
from APIAutoTest_3.common.read_basic_ini import ReadBasicIni


class ReadUserIni:
    @log_decorator
    def __init__(self, username):
        self.user_path = ReadBasicIni().get_user_dir_name(username)
        ini_path = os.path.join(self.user_path, 'config.ini')
        self.conf = configparser.ConfigParser()
        self.conf.read(ini_path, encoding='utf-8')

    @log_decorator
    def get_file_path(self, key):
        file_path = os.path.join(self.user_path, self.conf.get('file', key))
        return file_path

    @log_decorator
    def get_table_name(self, key):
        table_name = self.conf.get('table', key)
        return table_name

if __name__ == '__main__':

    print(ReadUserIni("farke").get_table_name('name'))
    print(ReadUserIni("shy").get_file_path('excel'))