# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   test
# FileName:      requests_method.py
# Author:       xxxxx
# Datetime:     2024/12/27 09:28
# Description:
# 
# ---------------------------------------------------------------------------
import requests

from APIAutoTest_3 import log_decorator
from APIAutoTest_3.common.db import DB
from APIAutoTest_3.common.read_basic_ini import ReadBasicIni


class RequestsMethod:
    @log_decorator
    def __init__(self):
        self.db = DB()
        self.bpm_session = requests.sessions.Session()
        login_url = ReadBasicIni().get_host("bpm") + "/auth"
        login_data = {"username": "admin","password": "WuHRoZXGrg1LHOix8EVOhqGcu3CEEd0hOWNPRENTScZMb2ekrEtBGGBJweUxGKi36k346+OrS5mD3nnjyrocZOfzo4UqoshNoqJgx09u81LV2vc53Sy83DsBWKGoZZZRUhsDrpRj8feUlakJMCpgqswG0y9jm95Lk9auWpI146I="}
        self.bpm_session.headers["Authorization"] = "Bearer " + self.bpm_session.post(url=login_url,json=login_data).json().get("token")

    @log_decorator
    def close(self):
        self.db.close()

    @log_decorator
    def request_all(self,req_url,req_mime,req_method,case_data,sql_type,sql_data,update_key):
        if sql_type == "select":
            select_result = self.db.select(sql_data)
            case_data[update_key] = select_result

        elif sql_type == "delete":
            self.db.delete(sql_data)

        elif sql_type == "delete|select" or sql_type == "select|delete":
            self.db.delete(sql_data["delete"])#执行删除
            select_result = self.db.select(sql_data["select"])#将查询结果更新
            case_data[update_key] = select_result

        # 发送请求
        # requests关心的是传参的关键字，不关心请求方法
        # 判断媒体类型是否为query|json或者json|query表示请求体使用json传参，同时也在地址栏传参
        if req_mime == "query|json" or req_mime == "json|query":
            return self.bpm_session.request(req_method,req_url,json=case_data["json"],params=case_data["query"])
        elif req_mime == "application/json" or req_mime == "json":
            return self.bpm_session.request(req_method,req_url,json=case_data)
        elif req_mime == "application/x-www-form-urlencoded" or req_mime == "form":
            return self.bpm_session.request(req_method,req_url,data=case_data)
        elif req_mime == "query":
            return self.bpm_session.request(req_method,req_url,params=case_data)
        elif req_mime == "multipart/form-data" or req_mime == "form-data":
            return self.bpm_session.request(req_method,req_url,files=case_data)
        elif req_mime is None:
            return self.bpm_session.request(req_method, url=req_url)
        else:
            raise ValueError("请求媒体类型错误，请检查！")

